---
title: Create or update a patterns configuration
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > LLM Observability
---

# Create or update a patterns configuration{% #create-or-update-a-patterns-configuration %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                |
| ----------------- | --------------------------------------------------------------------------- |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/topic-discovery-configs |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/topic-discovery-configs |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/llm-obs/v1/topic-discovery-configs      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/llm-obs/v1/topic-discovery-configs      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/topic-discovery-configs  |
| uk1.datadoghq.com | PUT https://api.uk1.datadoghq.com/api/v2/llm-obs/v1/topic-discovery-configs |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/llm-obs/v1/topic-discovery-configs     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/llm-obs/v1/topic-discovery-configs |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/llm-obs/v1/topic-discovery-configs |

### Overview

Create a new patterns configuration, or update an existing one when a configuration ID is provided.

### Request

#### Body Data (required)

Patterns configuration payload.

{% tab title="Model" %}

| Parent field | Field                             | Type   | Description                                                                                                  |
| ------------ | --------------------------------- | ------ | ------------------------------------------------------------------------------------------------------------ |
|              | data [*required*]            | object | Data object for creating or updating an LLM Observability patterns configuration.                            |
| data         | attributes [*required*]      | object | Attributes for creating or updating an LLM Observability patterns configuration.                             |
| attributes   | account_id                        | string | Integration account ID for a bring-your-own-model configuration.                                             |
| attributes   | config_id                         | string | The ID of an existing configuration to update. If omitted, a new configuration is created.                   |
| attributes   | evp_query [*required*]       | string | Query that selects the spans the patterns run analyzes.                                                      |
| attributes   | hierarchy_depth [*required*] | int32  | Depth of the topic hierarchy to generate.                                                                    |
| attributes   | integration_provider              | string | Integration provider for a bring-your-own-model configuration.                                               |
| attributes   | model_name                        | string | Model name for a bring-your-own-model configuration.                                                         |
| attributes   | name [*required*]            | string | Name of the configuration.                                                                                   |
| attributes   | num_records [*required*]     | int32  | Maximum number of records to process for the run.                                                            |
| attributes   | sampling_ratio [*required*]  | double | Fraction of matching spans to sample for the run.                                                            |
| attributes   | scope                             | string | Scope of the configuration.                                                                                  |
| attributes   | template                          | string | Template used to guide topic generation.                                                                     |
| data         | type [*required*]            | enum   | Resource type of an LLM Observability patterns configuration. Allowed enum values: `topic_discovery_configs` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "account_id": "1000000001",
      "config_id": "a7c8d9e0-1234-5678-9abc-def012345678",
      "evp_query": "@ml_app:support-bot",
      "hierarchy_depth": 2,
      "integration_provider": "openai",
      "model_name": "gpt-4o",
      "name": "Support chatbot topics",
      "num_records": 1000,
      "sampling_ratio": 0.1,
      "scope": "",
      "template": ""
    },
    "type": "topic_discovery_configs"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a single LLM Observability patterns configuration.

| Parent field | Field                             | Type      | Description                                                                                                  |
| ------------ | --------------------------------- | --------- | ------------------------------------------------------------------------------------------------------------ |
|              | data [*required*]            | object    | Data object of an LLM Observability patterns configuration.                                                  |
| data         | attributes [*required*]      | object    | Attributes of an LLM Observability patterns configuration.                                                   |
| attributes   | account_id                        | string    | Integration account ID for a bring-your-own-model configuration.                                             |
| attributes   | created_at [*required*]      | date-time | Timestamp when the configuration was created.                                                                |
| attributes   | evp_query [*required*]       | string    | Query that selects the spans the patterns run analyzes.                                                      |
| attributes   | hierarchy_depth [*required*] | int32     | Depth of the topic hierarchy to generate.                                                                    |
| attributes   | integration_provider              | string    | Integration provider for a bring-your-own-model configuration.                                               |
| attributes   | model_name                        | string    | Model name for a bring-your-own-model configuration.                                                         |
| attributes   | name [*required*]            | string    | Name of the configuration.                                                                                   |
| attributes   | num_records [*required*]     | int32     | Maximum number of records to process for the run.                                                            |
| attributes   | sampling_ratio [*required*]  | double    | Fraction of matching spans to sample for the run.                                                            |
| attributes   | scope [*required*]           | string    | Scope of the configuration.                                                                                  |
| attributes   | template                          | string    | Template used to guide topic generation.                                                                     |
| attributes   | updated_at [*required*]      | date-time | Timestamp when the configuration was last updated.                                                           |
| data         | id [*required*]              | string    | Unique identifier of the configuration.                                                                      |
| data         | type [*required*]            | enum      | Resource type of an LLM Observability patterns configuration. Allowed enum values: `topic_discovery_configs` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "account_id": "1000000001",
      "created_at": "2024-01-15T10:30:00Z",
      "evp_query": "@ml_app:support-bot",
      "hierarchy_depth": 2,
      "integration_provider": "openai",
      "model_name": "gpt-4o",
      "name": "Support chatbot topics",
      "num_records": 1000,
      "sampling_ratio": 0.1,
      "scope": "",
      "template": "",
      "updated_at": "2024-01-15T10:30:00Z"
    },
    "id": "a7c8d9e0-1234-5678-9abc-def012345678",
    "type": "topic_discovery_configs"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/llm-obs/v1/topic-discovery-configs" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "evp_query": "@ml_app:support-bot",
      "hierarchy_depth": 2,
      "name": "Support chatbot topics",
      "num_records": 1000,
      "sampling_ratio": 0.1
    },
    "type": "topic_discovery_configs"
  }
}
EOF 
                
##### 

```python
"""
Create or update a patterns configuration returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.llm_observability_api import LLMObservabilityApi
from datadog_api_client.v2.model.llm_obs_patterns_config_type import LLMObsPatternsConfigType
from datadog_api_client.v2.model.llm_obs_patterns_config_upsert_request import LLMObsPatternsConfigUpsertRequest
from datadog_api_client.v2.model.llm_obs_patterns_config_upsert_request_attributes import (
    LLMObsPatternsConfigUpsertRequestAttributes,
)
from datadog_api_client.v2.model.llm_obs_patterns_config_upsert_request_data import (
    LLMObsPatternsConfigUpsertRequestData,
)

body = LLMObsPatternsConfigUpsertRequest(
    data=LLMObsPatternsConfigUpsertRequestData(
        attributes=LLMObsPatternsConfigUpsertRequestAttributes(
            account_id="1000000001",
            config_id="a7c8d9e0-1234-5678-9abc-def012345678",
            evp_query="@ml_app:support-bot",
            hierarchy_depth=2,
            integration_provider="openai",
            model_name="gpt-4o",
            name="Support chatbot topics",
            num_records=1000,
            sampling_ratio=0.1,
            scope="",
            template="",
        ),
        type=LLMObsPatternsConfigType.TOPIC_DISCOVERY_CONFIGS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["upsert_llm_obs_patterns_config"] = True
with ApiClient(configuration) as api_client:
    api_instance = LLMObservabilityApi(api_client)
    response = api_instance.upsert_llm_obs_patterns_config(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create or update a patterns configuration returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.upsert_llm_obs_patterns_config".to_sym] = true
end
api_instance = DatadogAPIClient::V2::LLMObservabilityAPI.new

body = DatadogAPIClient::V2::LLMObsPatternsConfigUpsertRequest.new({
  data: DatadogAPIClient::V2::LLMObsPatternsConfigUpsertRequestData.new({
    attributes: DatadogAPIClient::V2::LLMObsPatternsConfigUpsertRequestAttributes.new({
      account_id: "1000000001",
      config_id: "a7c8d9e0-1234-5678-9abc-def012345678",
      evp_query: "@ml_app:support-bot",
      hierarchy_depth: 2,
      integration_provider: "openai",
      model_name: "gpt-4o",
      name: "Support chatbot topics",
      num_records: 1000,
      sampling_ratio: 0.1,
      scope: "",
      template: "",
    }),
    type: DatadogAPIClient::V2::LLMObsPatternsConfigType::TOPIC_DISCOVERY_CONFIGS,
  }),
})
p api_instance.upsert_llm_obs_patterns_config(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create or update a patterns configuration returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.LLMObsPatternsConfigUpsertRequest{
		Data: datadogV2.LLMObsPatternsConfigUpsertRequestData{
			Attributes: datadogV2.LLMObsPatternsConfigUpsertRequestAttributes{
				AccountId:           datadog.PtrString("1000000001"),
				ConfigId:            datadog.PtrString("a7c8d9e0-1234-5678-9abc-def012345678"),
				EvpQuery:            "@ml_app:support-bot",
				HierarchyDepth:      2,
				IntegrationProvider: datadog.PtrString("openai"),
				ModelName:           datadog.PtrString("gpt-4o"),
				Name:                "Support chatbot topics",
				NumRecords:          1000,
				SamplingRatio:       0.1,
				Scope:               datadog.PtrString(""),
				Template:            datadog.PtrString(""),
			},
			Type: datadogV2.LLMOBSPATTERNSCONFIGTYPE_TOPIC_DISCOVERY_CONFIGS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpsertLLMObsPatternsConfig", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewLLMObservabilityApi(apiClient)
	resp, r, err := api.UpsertLLMObsPatternsConfig(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `LLMObservabilityApi.UpsertLLMObsPatternsConfig`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `LLMObservabilityApi.UpsertLLMObsPatternsConfig`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create or update a patterns configuration returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.LlmObservabilityApi;
import com.datadog.api.client.v2.model.LLMObsPatternsConfigResponse;
import com.datadog.api.client.v2.model.LLMObsPatternsConfigType;
import com.datadog.api.client.v2.model.LLMObsPatternsConfigUpsertRequest;
import com.datadog.api.client.v2.model.LLMObsPatternsConfigUpsertRequestAttributes;
import com.datadog.api.client.v2.model.LLMObsPatternsConfigUpsertRequestData;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.upsertLLMObsPatternsConfig", true);
    LlmObservabilityApi apiInstance = new LlmObservabilityApi(defaultClient);

    LLMObsPatternsConfigUpsertRequest body =
        new LLMObsPatternsConfigUpsertRequest()
            .data(
                new LLMObsPatternsConfigUpsertRequestData()
                    .attributes(
                        new LLMObsPatternsConfigUpsertRequestAttributes()
                            .accountId("1000000001")
                            .configId("a7c8d9e0-1234-5678-9abc-def012345678")
                            .evpQuery("@ml_app:support-bot")
                            .hierarchyDepth(2)
                            .integrationProvider("openai")
                            .modelName("gpt-4o")
                            .name("Support chatbot topics")
                            .numRecords(1000)
                            .samplingRatio(0.1)
                            .scope("")
                            .template(""))
                    .type(LLMObsPatternsConfigType.TOPIC_DISCOVERY_CONFIGS));

    try {
      LLMObsPatternsConfigResponse result = apiInstance.upsertLLMObsPatternsConfig(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling LlmObservabilityApi#upsertLLMObsPatternsConfig");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create or update a patterns configuration returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_llm_observability::LLMObservabilityAPI;
use datadog_api_client::datadogV2::model::LLMObsPatternsConfigType;
use datadog_api_client::datadogV2::model::LLMObsPatternsConfigUpsertRequest;
use datadog_api_client::datadogV2::model::LLMObsPatternsConfigUpsertRequestAttributes;
use datadog_api_client::datadogV2::model::LLMObsPatternsConfigUpsertRequestData;

#[tokio::main]
async fn main() {
    let body = LLMObsPatternsConfigUpsertRequest::new(LLMObsPatternsConfigUpsertRequestData::new(
        LLMObsPatternsConfigUpsertRequestAttributes::new(
            "@ml_app:support-bot".to_string(),
            2,
            "Support chatbot topics".to_string(),
            1000,
            0.1,
        )
        .account_id("1000000001".to_string())
        .config_id("a7c8d9e0-1234-5678-9abc-def012345678".to_string())
        .integration_provider("openai".to_string())
        .model_name("gpt-4o".to_string())
        .scope("".to_string())
        .template("".to_string()),
        LLMObsPatternsConfigType::TOPIC_DISCOVERY_CONFIGS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpsertLLMObsPatternsConfig", true);
    let api = LLMObservabilityAPI::with_config(configuration);
    let resp = api.upsert_llm_obs_patterns_config(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create or update a patterns configuration returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.upsertLLMObsPatternsConfig"] = true;
const apiInstance = new v2.LLMObservabilityApi(configuration);

const params: v2.LLMObservabilityApiUpsertLLMObsPatternsConfigRequest = {
  body: {
    data: {
      attributes: {
        accountId: "1000000001",
        configId: "a7c8d9e0-1234-5678-9abc-def012345678",
        evpQuery: "@ml_app:support-bot",
        hierarchyDepth: 2,
        integrationProvider: "openai",
        modelName: "gpt-4o",
        name: "Support chatbot topics",
        numRecords: 1000,
        samplingRatio: 0.1,
        scope: "",
        template: "",
      },
      type: "topic_discovery_configs",
    },
  },
};

apiInstance
  .upsertLLMObsPatternsConfig(params)
  .then((data: v2.LLMObsPatternsConfigResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
